#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <errno.h>

#include <time.h>

#include <extdll.h>
#include <sdk_util.h>
#include <meta_api.h>
#include <cbase.h>

#include "webmod.h"
#include "msg.h"


fun_t modMsgs[MAX_REG_MSGS];
fun_t modMsgsEnd[MAX_REG_MSGS];

int	gmsgCurWeapon;
int	gmsgDeathMsg;
int	gmsgDamage;
int	gmsgTextMsg;
int	gmsgTeamInfo;
int	gmsgWeaponList;
int	gmsgResetHUD;
int	gmsgintermission;
int gmsgMOTD;
int gmsgServerName;
int gmsgHealth;
int gmsgAmmoX;
int gmsgBattery;
int gmsgShowMenu;
int	gmsgVGUIMenu;
int gmsgSendAudio;
int gmsgTeamScore;
int gmsgMoney;
int	gmsgBleeding;
int	gmsgBandaging;
int gmsgScreenFade;
int gmsgScoreInfo;
int	gmsgAmmoPickup;
int	gmsgWeapPickup;
int gmsgHudText;

int mPlayerIndex;
player_t *mPlayer;
int mState;
void (*function)(void*);
void (*endfunction)(void*);


void Client_TeamInfo(void* mValue)
{	
	if (mPlayer) 
		return;

	static int index;

	switch (mState++) {
	case 0:
		index = *(int*)mValue;
		break;
	case 1:
		player_t*pPlayer = INDEXPLAYER( index );
		edict_t* pEntity = MYINDEXENT(index);
		pPlayer->team = (char*)mValue;
LOG_DBG_API(("Player #%d '%s' joined team '%s'",index,STRING(pEntity->v.netname),(char*)mValue));
	}
}

void Client_WeapPickup(void *mValue)
{
	if(mPlayer && *(int*)mValue==6)
	{
	int i;
		for(i=1;i<=gpGlobals->maxClients;i++)
			INDEXPLAYER(i)->bomb = false;
		mPlayer->bomb = true;
LOG_DBG_API(("Player #%d '%s' got the bomb",mPlayerIndex,STRING(mPlayer->pEdict->v.netname)));
	}
}

void Client_TextMsg(void *mValue)
{
	switch(mState++) {
	case 0:
		break;
	case 1:
		if(!strcmp((char*)mValue,"#Game_bomb_drop") || !strcmp((char*)mValue,"#Bomb_Planted"))
		{
		int i;
			for(i=1;i<=gpGlobals->maxClients;i++)
				players[i].bomb = false;
LOG_DBG_API(("No more bomb carrier"));
		}
		break;
	case 2:
		break;
	}
}

void Client_ScoreInfo(void* mValue)
{
	static int index;
	static int deaths;
	switch (mState++){
	case 0:
		index = *(int*)mValue;
		break;
	case 2:
		deaths = *(int*)mValue;
		break;
	case 4:
		player_t*pPlayer = INDEXPLAYER( index );
		pPlayer->team_id = *(int*)mValue;
		pPlayer->deaths = deaths;
LOG_DBG_API(("Player #%d '%s' : %d deaths, team #%d",index,STRING(pPlayer->pEdict->v.netname),deaths,*(int*)mValue));
	}
}

void Client_TeamScore(void *mValue)
{
	int i;
	static char *tname;

	switch(mState++) {
	case 0:
		tname = (char*)mValue;
		break;
	case 1:
		for(i=0;i<32;i++)
		{
			if(teams[i].name[0]=='\0' || !strcmp(teams[i].name,tname))
				break;
		}
		if(i<32)
		{
			teams[i].score = *(int*)mValue;
			if(teams[i].name[0]=='\0')
				strncpy(teams[i].name,tname,64);
LOG_DBG_API(("Team '%s' scored %d",tname,teams[i].score));
		}
		break;
	}
}

void Client_HudText(void *mValue)
{
	switch(mState++) {
	case 0:
//LOG_MESSAGE(PLID,"HudText to #%d : '%s'",mPlayerIndex,(char*)mValue);
		if(!strcmp((char*)mValue,"#Hint_you_are_the_vip"))
		{
		int i;
			for(i=1;i<=gpGlobals->maxClients;i++)
				INDEXPLAYER(i)->vip = false;
			mPlayer->vip = true;
LOG_DBG_API(("Player #%d '%s' is the VIP",mPlayerIndex,STRING(mPlayer->pEdict->v.netname)));

		}
		break;
	}
}

void Client_ResetHUD(void *)
{

}

void ServerActivate_Post( edict_t *pEdictList, int edictCount, int clientMax )
{
	int i;

	for(i=0;i<MAX_REG_MSGS;i++)
	{
		modMsgs[i].function = NULL;
		modMsgsEnd[i].function = NULL;
	}

	gmsgCurWeapon	=	GET_USER_MSG_ID(PLID, "CurWeapon", NULL );
	gmsgDamage		=	GET_USER_MSG_ID(PLID, "Damage", NULL );
	gmsgDeathMsg	=	GET_USER_MSG_ID(PLID, "DeathMsg", NULL );
	gmsgTextMsg		=	GET_USER_MSG_ID(PLID, "TextMsg", NULL );
	gmsgTeamInfo	=	GET_USER_MSG_ID(PLID, "TeamInfo", NULL );
	gmsgWeaponList	=	GET_USER_MSG_ID(PLID, "WeaponList", NULL );
	gmsgResetHUD	=   GET_USER_MSG_ID(PLID, "ResetHUD", NULL );
	gmsgMOTD		=	GET_USER_MSG_ID(PLID, "MOTD", NULL );
	gmsgServerName	=	GET_USER_MSG_ID(PLID, "ServerName", NULL );
	gmsgHealth		=	GET_USER_MSG_ID(PLID, "Health", NULL);
	gmsgBattery		=	GET_USER_MSG_ID(PLID, "Battery", NULL);
	gmsgShowMenu	=	GET_USER_MSG_ID(PLID, "ShowMenu", NULL);
	gmsgSendAudio	=	GET_USER_MSG_ID(PLID, "SendAudio", NULL);
	gmsgTeamScore	=	GET_USER_MSG_ID(PLID, "TeamScore", NULL);
	gmsgMoney		=	GET_USER_MSG_ID(PLID, "Money", NULL);
	gmsgAmmoX		=	GET_USER_MSG_ID(PLID, "AmmoX", NULL);
	gmsgBleeding	=	GET_USER_MSG_ID(PLID, "Bleeding", NULL);
	gmsgBandaging	=	GET_USER_MSG_ID(PLID, "Bandaging", NULL);
	gmsgScreenFade  =	GET_USER_MSG_ID(PLID, "ScreenFade",NULL);
	gmsgScoreInfo	=	GET_USER_MSG_ID(PLID, "ScoreInfo", NULL);
	gmsgVGUIMenu	=	GET_USER_MSG_ID(PLID, "VGUIMenu", NULL);
	gmsgAmmoPickup	=	GET_USER_MSG_ID(PLID, "AmmoPickup", NULL);
	gmsgWeapPickup	=	GET_USER_MSG_ID(PLID, "WeapPickup", NULL);
	gmsgHudText		=	GET_USER_MSG_ID(PLID, "HudText", NULL);

	modMsgs[gmsgTeamInfo].function = Client_TeamInfo;
	modMsgs[gmsgTeamScore].function = Client_TeamScore;
	modMsgs[gmsgScoreInfo].function = Client_ScoreInfo;
	modMsgs[gmsgWeapPickup].function = Client_WeapPickup;
	modMsgs[gmsgTextMsg].function = Client_TextMsg;
	modMsgs[gmsgHudText].function = Client_HudText;
	modMsgsEnd[gmsgResetHUD].function = Client_ResetHUD;

	RETURN_META(MRES_IGNORED);
}


void MessageBegin(int msg_dest, int msg_type, const float *pOrigin, edict_t *ed)
{
	if(ed)
	{
		mPlayer = ENTPLAYER(ed);
		mPlayerIndex = ENTINDEX(ed);
	}
	else
	{
		mPlayer = NULL;
		mPlayerIndex = 0;
	}

	mState = 0;

	function=modMsgs[msg_type].function;
	endfunction=modMsgsEnd[msg_type].function;

	RETURN_META(MRES_HANDLED);
}

void MessageEnd(void)
{
	if (endfunction) (*endfunction)(NULL);
	RETURN_META(MRES_HANDLED);
}

void WriteByte(int iValue)
{
	if (function) (*function)((void *)&iValue);
	RETURN_META(MRES_HANDLED);
}

void WriteChar(int iValue)
{
	if (function) (*function)((void *)&iValue);
	RETURN_META(MRES_HANDLED);
}

void WriteShort(int iValue)
{
	if (function) (*function)((void *)&iValue);
	RETURN_META(MRES_HANDLED);
}

void WriteLong(int iValue)
{
	if (function) (*function)((void *)&iValue);
	RETURN_META(MRES_HANDLED);
}

void WriteAngle(float flValue)
{
	if (function) (*function)((void *)&flValue);
	RETURN_META(MRES_HANDLED);
}

void WriteCoord(float flValue)
{
	if (function) (*function)((void *)&flValue);
	RETURN_META(MRES_HANDLED);
}

void WriteString(const char *sz)
{
	if (function) (*function)((void *)sz);
	RETURN_META(MRES_HANDLED);
}

void WriteEntity(int iValue)
{
	if (function) (*function)((void *)&iValue);
	RETURN_META(MRES_HANDLED);
}
